<p align="center">
  <img src="https://nebula-website-cn.oss-cn-hangzhou.aliyuncs.com/nebula-website/images/nebulagraph-logo.png"/>
  <br> English | <a href="README-CN.md">中文</a>
  <br>A distributed, scalable, lightning-fast graph database<br>
</p>
<p align="center">
  <a href="https://app.codecov.io/gh/vesoft-inc/nebula">
    <img src="https://codecov.io/github/vesoft-inc/nebula/coverage.svg?branch=master" alt="code coverage"/>
  </a>
  <a href="https://github.com/vesoft-inc/nebula/actions?workflow=nightly">
    <img src="https://github.com/vesoft-inc/nebula/workflows/nightly/badge.svg" alt="nightly build"/>
  </a>
  <a href="https://github.com/vesoft-inc/nebula/stargazers">
    <img src="http://githubbadges.com/star.svg?user=vesoft-inc&repo=nebula&style=default" alt="nebula star"/>
  </a>
  <a href="https://github.com/vesoft-inc/nebula/network/members">
    <img src="http://githubbadges.com/fork.svg?user=vesoft-inc&repo=nebula&style=default" alt="nebula fork"/>
  </a>
  <br>
</p>

# What is Nebula Graph?

**Nebula Graph** is an open-source graph database capable of hosting super large scale graphs with dozens of billions of vertices (nodes) and trillions of edges, with milliseconds of latency.

Compared with other graph database solutions, **Nebula Graph** has the following advantages:

* Symmetrically distributed
* Storage and computing separation
* Horizontal scalability
* Strong data consistency by RAFT protocol
* OpenCypher-compatible query language
* Role-based access control for higher level security

## Notice of Release

This repository hosts the source code of Nebula Graph versions before 2.0.0-alpha and after v2.5.x. If you are looking to use the versions between v2.0.0 and v2.5.x, please head to [Nebula Graph repo](https://github.com/vesoft-inc/nebula-graph).

Nebula Graph 1.x is not actively maintained. Please move to Nebula Graph 2.x. The data format, rpc protocols, clients, etc. are not compatible between Nebula Graph v1.x and v2.x, but we do offer [upgrade guide](https://docs.nebula-graph.io/2.5.0/4.deployment-and-installation/3.upgrade-nebula-graph/upgrade-nebula-graph-to-250/).

<!--
To use the stable release, see [Nebula Graph 1.0](https://github.com/vesoft-inc/nebula).


## Roadmap

See our [Roadmap](https://github.com/vesoft-inc/nebula/wiki/Nebula-Graph-Roadmap-2020) for what's coming soon in **Nebula Graph**.
-->

## Quick start

Read the [Getting started](https://docs.nebula-graph.io/2.0/2.quick-start/1.quick-start-workflow/) article for a quick start.

<!--
Please note that you need to install **Nebula Graph**, either by [installing source code](https://docs.nebula-graph.io/manual-EN/3.build-develop-and-administration/1.build/1.build-source-code/) or by [docker compose](https://docs.nebula-graph.io/manual-EN/3.build-develop-and-administration/1.build/2.build-by-docker/), before you can actually start using it. If you prefer a video tutorial, visit our [YouTube channel](https://www.youtube.com/channel/UC73V8q795eSEMxDX4Pvdwmw/videos).
-->

## Getting help
In case you encounter any problems playing around **Nebula Graph**, please reach out for help:
* [FAQ](https://docs.nebula-graph.io/2.0/2.quick-start/0.FAQ/)
* [Discussions](https://github.com/vesoft-inc/nebula/discussions)

## Documentation

* [English](https://docs.nebula-graph.io/)

## Architecture
![Nebula Graph Architecture](https://docs-cdn.nebula-graph.com.cn/figures/nebula-graph-architecture_3.png)

## Contributing

Contributions are warmly welcomed and greatly appreciated. And here are a few ways you can contribute:

* Start by some [issues](https://github.com/vesoft-inc/nebula/issues)
* Submit Pull Requests to us. See [how-to-contribute](https://docs.nebula-graph.io/master/15.contribution/how-to-contribute/).

## Landscape

<p align="left">
<img src="https://landscape.cncf.io/images/left-logo.svg" width="150">&nbsp;&nbsp;<img src="https://landscape.cncf.io/images/right-logo.svg" width="200" />
<br />

[Nebula Graph](https://landscape.cncf.io/?selected=nebula-graph) enriches the <a href="https://landscape.cncf.io/card-mode?category=database&grouping=category">
CNCF Database Landscape.</a>
</p>

## Licensing

**Nebula Graph** is under [Apache 2.0](https://www.apache.org/licenses/LICENSE-2.0) license, so you can freely download, modify, and deploy the source code to meet your needs. You can also freely deploy **Nebula Graph** as a back-end service to support your SaaS deployment.

## Contact

* [Slack channel](https://join.slack.com/t/nebulagraph/shared_invite/zt-7ybejuqa-NCZBroh~PCh66d9kOQj45g)
* [Stack Overflow](https://stackoverflow.com/questions/tagged/nebulagraph)
* Twitter: [@NebulaGraph](https://twitter.com/NebulaGraph)
* [LinkedIn page](https://www.linkedin.com/company/vesoft-nebula-graph)
* email: info@vesoft.com
